schema_name   : args
schema_version: 1.0
schema_type   : peripheral

hdl_library_name       : LFAADecode100G
hdl_library_description: "Monitor and Control of decoding of LFAA data from 100GE"

peripherals:
  - peripheral_name        : LFAADecode100G
    peripheral_description : "Registers associated with LFAA Decode"
    slave_ports:
      - slave_name        : VCStats
        slave_type        : RAM
        number_of_slaves  : 1
        slave_description : " VC_STATS
                              This address space arrangement has been optimised for all 3 SPEAD formats, some fields return 0 when not used.
                              Base Address 0, range 8192
                              Status for each virtual channel. 8 words per virtual channel. Each group of 8 words has
                              (1) most recent logical channel in bits(15:0), most recent nof_contributing_antennas in bits(31:16),
                              (2) most recent SPEAD timestamp bits(31:0)    (for V1 and V2, Zeroed in v3)
                              (3) bits(31:28) = 4 bit count of packets with out of order packet numbers (wraps on overflow), bits(27:0) = PTP uptime fractional second (31 -> 4), units of 16ns
                              (4) PTP uptime whole seconds (Bits 64 -> 32) of the 80 bit timestamp.
                              (5) latest packet number bits(31:0),          (Packet Number Since TAI, 40 bits, in v3)
                              (6) latest packet number bits(47:32), 
                              (7) most recent SPEAD sync time, bits(31:0)   (for V1 and V2, Zeroed in v3)
                              (8) most recent SPEAD sync time, bits(47:32)  (for V1 and V2, Zeroed in v3).

                              VC_TABLE
                              Base Address 8192, range 4096
                              Virtual channel table. Two copies in addresses 0-2047 and 2048-4095. The one used is determined by bit 1 of the control register.
                                   Each entry has 2 words :\
                                    First word : \
                                      bits 2:0   = substation_id, \
                                      bits 12:3  = station_id,    \
                                      bits 16:13 = beam_id, \
                                      bits 25:17 = frequency_id  \
                                      bits 30:26 = subarray_id \
                                      bit  31    = set to '1' to indicate this entry is valid \
                                    Second Word : \
                                      bits (9:0) =  Virtual channel.  \
                                   The maximum number of valid entries in this table is defined by total_channels.\
                                   Used virtual channels must be packed into the lower end of the addresses in the VCTable.\
                                   For example, if there are 128 virtual channels, then they must be in entries 0 to 127 of this table.\
                                   Virtual channels must be sorted according to the value in the first word in each entry. \
                                   So for example if there are 3 stations with ids (5, 10, 12) and 2 channels with ids (100, 101), 
                                   then they would be listed in this table as
                                    0 - station 5, channel 100 \
                                    1 - station 10, channel 100 \
                                    2 - station 12, channel 100 \
                                    3 - station 5, channel 101 \
                                    4 - station 10, channel 101 \
                                    5 - station 12, channel 101 \
                              "
        fields            :
          - - field_name        : data
              width             : 32
              user_width        : 32
              access_mode       : RW
              number_of_fields  : 16384
              interface         : simple
              reset_value       : 0
              field_description : "Status for each virtual channel."
      #################################################################
      - slave_name        : StatCtrl
        slave_type        : reg
        number_of_slaves  : 1
        slave_description : "Registers associated with LFAA Decode"
        dual_clock        : false
        fields:
          - - field_name        : table_select
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Select which virtual channel table to use; 0 for first half (table addresses 0-1023), 1 for second half (table addresses 1024-2047)"
          #################################
          - - field_name        : total_stations
              width             : 16
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Number of different stations to process in this FPGA."
          #################################
          - - field_name        : total_coarse
              width             : 16
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Total number of coarse channels to process in this FPGA."
          #################################
          - - field_name        : total_channels
              width             : 16
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Total number of virtual channels to process in this FPGA. Should be total_stations * total_coarse."
          #################################
          - - field_name        : SPEAD_packet_count
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of LFAA SPEAD packets received, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : NONSPEAD_packet_count
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of non-LFAA SPEAD packets received, 32 bit saturating, reset on write."
          #################################
          - - field_name        : badEthernetFrames
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of ethernet packets with errors (e.g. too short, too long, or FCS bad), reset on write."
          #################################
          - - field_name        : badIPUDPFrames
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of ethernet packets with bad IP or UDP checksums, reset on write."
          #################################
          - - field_name        : NoVirtualChannelCount
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that did not match an entry in the virtual channel table, reset on write."
          #################################
          - - field_name        : spead_v1_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead v1 headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : spead_v2_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead v2 headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : spead_v3_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead v3 headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : non_spead_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : HBM_reset
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set this to 1 and then monitor HBM_reset status."
          #################################
          - - field_name        : HBM_reset_status
              width             : 8
              access_mode       : RO
              reset_value       : 0x0
              field_description : "When this reads 1 then both HBM read and WR queues have been zeroed out, ready to reconfigure logic."
          #################################
          - - field_name        : lfaa_decode_reset
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set this to 1 to return all statemachines to IDLE"
          #################################
          - - field_name        : lfaa_tx_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : lfaa_stats_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : lfaa_rx_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : lfaa_lookup_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : uram_buffer_level
              width             : 16
              access_mode       : RO
              reset_value       : 0x0
              field_description : "This is has a max value of 4096."
          #################################
          - - field_name        : uram_buffer_fill_warn
              width             : 16
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Bit 15 will indicate > 4000 positions in the FIFO used, lower bits will record max value"
          #################################
          - - field_name        : inc_packet_burst_warn
              width             : 16
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Rolling counter that indicates how often the following occurs.
                                   The peak data rate for 100 consecutive packets on a link shall
                                   be no more than 20% above the average data rate of 69.3 Gbps. NOT IMPLEMENTED"
          #################################
          - - field_name        : inc_data_rate_sec
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Four values spread across the vector.
                                   Each value is 8 bit, upper 7 bits have a max value of 99 and the
                                   remaining bit indicates 0.5
                                    7->0    = 0    - 0.25 sec
                                    15->8   = 0.25 - 0.5
                                    23->16  = 0.5  - 0.75
                                    31->24  = 0.75 - 1 sec
                                    NOT IMPLEMENTED
                                  "
          #################################
          - - field_name        : inc_data_rate_min
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Four values spread across the vector.
                                   Each value is 8 bit, upper 7 bits have a max value of 99 and the
                                   remaining bit indicates 0.5
                                    7->0    = 0    - 0.25 min
                                    15->8   = 0.25 - 0.5
                                    23->16  = 0.5  - 0.75
                                    31->24  = 0.75 - 1 min
                                    NOT IMPLEMENTED
                                  "

  - peripheral_name        : LFAADecode100G_2
    peripheral_description : "Registers associated with LFAA Decode"
    slave_ports:
      - slave_name        : VCStats
        slave_type        : RAM
        number_of_slaves  : 1
        slave_description : " VC_STATS
                              This address space arrangement has been optimised for all 3 SPEAD formats, some fields return 0 when not used.
                              Base Address 0, range 8192
                              Status for each virtual channel. 8 words per virtual channel. Each group of 8 words has
                              (1) most recent logical channel in bits(15:0), most recent nof_contributing_antennas in bits(31:16),
                              (2) most recent SPEAD timestamp bits(31:0)    (for V1 and V2, Zeroed in v3)
                              (3) bits(31:28) = 4 bit count of packets with out of order packet numbers (wraps on overflow), bits(27:0) = PTP uptime fractional second (31 -> 4), units of 16ns
                              (4) PTP uptime whole seconds (Bits 64 -> 32) of the 80 bit timestamp.
                              (5) latest packet number bits(31:0),          (Packet Number Since TAI, 40 bits, in v3)
                              (6) latest packet number bits(47:32), 
                              (7) most recent SPEAD sync time, bits(31:0)   (for V1 and V2, Zeroed in v3)
                              (8) most recent SPEAD sync time, bits(47:32)  (for V1 and V2, Zeroed in v3).

                              VC_TABLE
                              Base Address 8192, range 4096
                              Virtual channel table. Two copies in addresses 0-2047 and 2048-4095. The one used is determined by bit 1 of the control register.
                                   Each entry has 2 words :\
                                    First word : \
                                      bits 2:0   = substation_id, \
                                      bits 12:3  = station_id,    \
                                      bits 16:13 = beam_id, \
                                      bits 25:17 = frequency_id  \
                                      bits 30:26 = subarray_id \
                                      bit  31    = set to '1' to indicate this entry is valid \
                                    Second Word : \
                                      bits (9:0) =  Virtual channel.  \
                                   The maximum number of valid entries in this table is defined by total_channels.\
                                   Used virtual channels must be packed into the lower end of the addresses in the VCTable.\
                                   For example, if there are 128 virtual channels, then they must be in entries 0 to 127 of this table.\
                                   Virtual channels must be sorted according to the value in the first word in each entry. \
                                   So for example if there are 3 stations with ids (5, 10, 12) and 2 channels with ids (100, 101), 
                                   then they would be listed in this table as
                                    0 - station 5, channel 100 \
                                    1 - station 10, channel 100 \
                                    2 - station 12, channel 100 \
                                    3 - station 5, channel 101 \
                                    4 - station 10, channel 101 \
                                    5 - station 12, channel 101 \
                              "
        fields            :
          - - field_name        : data
              width             : 32
              user_width        : 32
              access_mode       : RW
              number_of_fields  : 16384
              interface         : simple
              reset_value       : 0
              field_description : "Status for each virtual channel."
      #################################################################
      - slave_name        : StatCtrl
        slave_type        : reg
        number_of_slaves  : 1
        slave_description : "Registers associated with LFAA Decode"
        dual_clock        : false
        fields:
          - - field_name        : table_select
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Select which virtual channel table to use; 0 for first half (table addresses 0-1023), 1 for second half (table addresses 1024-2047)"
          #################################
          - - field_name        : total_stations
              width             : 16
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Number of different stations to process in this FPGA."
          #################################
          - - field_name        : total_coarse
              width             : 16
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Total number of coarse channels to process in this FPGA."
          #################################
          - - field_name        : total_channels
              width             : 16
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Total number of virtual channels to process in this FPGA. Should be total_stations * total_coarse."
          #################################
          - - field_name        : SPEAD_packet_count
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of LFAA SPEAD packets received, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : NONSPEAD_packet_count
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of non-LFAA SPEAD packets received, 32 bit saturating, reset on write."
          #################################
          - - field_name        : badEthernetFrames
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of ethernet packets with errors (e.g. too short, too long, or FCS bad), reset on write."
          #################################
          - - field_name        : badIPUDPFrames
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of ethernet packets with bad IP or UDP checksums, reset on write."
          #################################
          - - field_name        : NoVirtualChannelCount
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that did not match an entry in the virtual channel table, reset on write."
          #################################
          - - field_name        : spead_v1_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead v1 headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : spead_v2_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead v2 headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : spead_v3_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead v3 headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : non_spead_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : HBM_reset
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set this to 1 and then monitor HBM_reset status."
          #################################
          - - field_name        : HBM_reset_status
              width             : 8
              access_mode       : RO
              reset_value       : 0x0
              field_description : "When this reads 1 then both HBM read and WR queues have been zeroed out, ready to reconfigure logic."
          #################################
          - - field_name        : lfaa_decode_reset
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set this to 1 to return all statemachines to IDLE"
          #################################
          - - field_name        : lfaa_tx_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : lfaa_stats_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : lfaa_rx_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : lfaa_lookup_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : uram_buffer_level
              width             : 16
              access_mode       : RO
              reset_value       : 0x0
              field_description : "This is has a max value of 4096."
          #################################
          - - field_name        : uram_buffer_fill_warn
              width             : 16
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Bit 15 will indicate > 4000 positions in the FIFO used, lower bits will record max value"
          #################################
          - - field_name        : inc_packet_burst_warn
              width             : 16
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Rolling counter that indicates how often the following occurs.
                                   The peak data rate for 100 consecutive packets on a link shall
                                   be no more than 20% above the average data rate of 69.3 Gbps. NOT IMPLEMENTED"
          #################################
          - - field_name        : inc_data_rate_sec
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Four values spread across the vector.
                                   Each value is 8 bit, upper 7 bits have a max value of 99 and the
                                   remaining bit indicates 0.5
                                    7->0    = 0    - 0.25 sec
                                    15->8   = 0.25 - 0.5
                                    23->16  = 0.5  - 0.75
                                    31->24  = 0.75 - 1 sec
                                    NOT IMPLEMENTED
                                  "
          #################################
          - - field_name        : inc_data_rate_min
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Four values spread across the vector.
                                   Each value is 8 bit, upper 7 bits have a max value of 99 and the
                                   remaining bit indicates 0.5
                                    7->0    = 0    - 0.25 min
                                    15->8   = 0.25 - 0.5
                                    23->16  = 0.5  - 0.75
                                    31->24  = 0.75 - 1 min
                                    NOT IMPLEMENTED
                                  "

  - peripheral_name        : LFAADecode100G_3
    peripheral_description : "Registers associated with LFAA Decode"
    slave_ports:
      - slave_name        : VCStats
        slave_type        : RAM
        number_of_slaves  : 1
        slave_description : " VC_STATS
                              This address space arrangement has been optimised for all 3 SPEAD formats, some fields return 0 when not used.
                              Base Address 0, range 8192
                              Status for each virtual channel. 8 words per virtual channel. Each group of 8 words has
                              (1) most recent logical channel in bits(15:0), most recent nof_contributing_antennas in bits(31:16),
                              (2) most recent SPEAD timestamp bits(31:0)    (for V1 and V2, Zeroed in v3)
                              (3) bits(31:28) = 4 bit count of packets with out of order packet numbers (wraps on overflow), bits(27:0) = PTP uptime fractional second (31 -> 4), units of 16ns
                              (4) PTP uptime whole seconds (Bits 64 -> 32) of the 80 bit timestamp.
                              (5) latest packet number bits(31:0),          (Packet Number Since TAI, 40 bits, in v3)
                              (6) latest packet number bits(47:32), 
                              (7) most recent SPEAD sync time, bits(31:0)   (for V1 and V2, Zeroed in v3)
                              (8) most recent SPEAD sync time, bits(47:32)  (for V1 and V2, Zeroed in v3).

                              VC_TABLE
                              Base Address 8192, range 4096
                              Virtual channel table. Two copies in addresses 0-2047 and 2048-4095. The one used is determined by bit 1 of the control register.
                                   Each entry has 2 words :\
                                    First word : \
                                      bits 2:0   = substation_id, \
                                      bits 12:3  = station_id,    \
                                      bits 16:13 = beam_id, \
                                      bits 25:17 = frequency_id  \
                                      bits 30:26 = subarray_id \
                                      bit  31    = set to '1' to indicate this entry is valid \
                                    Second Word : \
                                      bits (9:0) =  Virtual channel.  \
                                   The maximum number of valid entries in this table is defined by total_channels.\
                                   Used virtual channels must be packed into the lower end of the addresses in the VCTable.\
                                   For example, if there are 128 virtual channels, then they must be in entries 0 to 127 of this table.\
                                   Virtual channels must be sorted according to the value in the first word in each entry. \
                                   So for example if there are 3 stations with ids (5, 10, 12) and 2 channels with ids (100, 101), 
                                   then they would be listed in this table as
                                    0 - station 5, channel 100 \
                                    1 - station 10, channel 100 \
                                    2 - station 12, channel 100 \
                                    3 - station 5, channel 101 \
                                    4 - station 10, channel 101 \
                                    5 - station 12, channel 101 \
                              "
        fields            :
          - - field_name        : data
              width             : 32
              user_width        : 32
              access_mode       : RW
              number_of_fields  : 16384
              interface         : simple
              reset_value       : 0
              field_description : "Status for each virtual channel."
      #################################################################
      - slave_name        : StatCtrl
        slave_type        : reg
        number_of_slaves  : 1
        slave_description : "Registers associated with LFAA Decode"
        dual_clock        : false
        fields:
          - - field_name        : table_select
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Select which virtual channel table to use; 0 for first half (table addresses 0-1023), 1 for second half (table addresses 1024-2047)"
          #################################
          - - field_name        : total_stations
              width             : 16
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Number of different stations to process in this FPGA."
          #################################
          - - field_name        : total_coarse
              width             : 16
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Total number of coarse channels to process in this FPGA."
          #################################
          - - field_name        : total_channels
              width             : 16
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Total number of virtual channels to process in this FPGA. Should be total_stations * total_coarse."
          #################################
          - - field_name        : SPEAD_packet_count
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of LFAA SPEAD packets received, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : NONSPEAD_packet_count
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of non-LFAA SPEAD packets received, 32 bit saturating, reset on write."
          #################################
          - - field_name        : badEthernetFrames
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of ethernet packets with errors (e.g. too short, too long, or FCS bad), reset on write."
          #################################
          - - field_name        : badIPUDPFrames
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of ethernet packets with bad IP or UDP checksums, reset on write."
          #################################
          - - field_name        : NoVirtualChannelCount
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that did not match an entry in the virtual channel table, reset on write."
          #################################
          - - field_name        : spead_v1_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead v1 headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : spead_v2_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead v2 headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : spead_v3_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead v3 headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : non_spead_packet_found
              width             : 32
              access_mode       : CW
              reset_value       : 0x0
              field_description : "Count of packets that match spead headers, 32 bit wrapping, reset on write."
          #################################
          - - field_name        : HBM_reset
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set this to 1 and then monitor HBM_reset status."
          #################################
          - - field_name        : HBM_reset_status
              width             : 8
              access_mode       : RO
              reset_value       : 0x0
              field_description : "When this reads 1 then both HBM read and WR queues have been zeroed out, ready to reconfigure logic."
          #################################
          - - field_name        : lfaa_decode_reset
              width             : 1
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Set this to 1 to return all statemachines to IDLE"
          #################################
          - - field_name        : lfaa_tx_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : lfaa_stats_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : lfaa_rx_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : lfaa_lookup_fsm_debug
              width             : 4
              access_mode       : RO
              reset_value       : 0x0
              field_description : "If this returns 0xF, then held in reset otherwise it is running"
          #################################
          - - field_name        : uram_buffer_level
              width             : 16
              access_mode       : RO
              reset_value       : 0x0
              field_description : "This is has a max value of 4096."
          #################################
          - - field_name        : uram_buffer_fill_warn
              width             : 16
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Bit 15 will indicate > 4000 positions in the FIFO used, lower bits will record max value"
          #################################
          - - field_name        : inc_packet_burst_warn
              width             : 16
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Rolling counter that indicates how often the following occurs.
                                   The peak data rate for 100 consecutive packets on a link shall
                                   be no more than 20% above the average data rate of 69.3 Gbps. NOT IMPLEMENTED"
          #################################
          - - field_name        : inc_data_rate_sec
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Four values spread across the vector.
                                   Each value is 8 bit, upper 7 bits have a max value of 99 and the
                                   remaining bit indicates 0.5
                                    7->0    = 0    - 0.25 sec
                                    15->8   = 0.25 - 0.5
                                    23->16  = 0.5  - 0.75
                                    31->24  = 0.75 - 1 sec
                                    NOT IMPLEMENTED
                                  "
          #################################
          - - field_name        : inc_data_rate_min
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Four values spread across the vector.
                                   Each value is 8 bit, upper 7 bits have a max value of 99 and the
                                   remaining bit indicates 0.5
                                    7->0    = 0    - 0.25 min
                                    15->8   = 0.25 - 0.5
                                    23->16  = 0.5  - 0.75
                                    31->24  = 0.75 - 1 min
                                    NOT IMPLEMENTED
                                  "